/*
	FastSCDRamCDLoad by Orion_ [04/2010] http://onorisoft.free.fr/

	FastSCDRamCDLoad(Overlay Index, Sector Base, Size, SCD Bank);
*/

char	CLSRtmpbank;
int		CLSRtmpsize;
int		CLSRtmpsect;

#pragma fastcall FastSCDRamCDLoad(byte al, word bx, word cx, byte ah);

FastSCDRamCDLoad()
{
#asm
	_FastSCDRamCDLoad.4:

	; _al = Overlay index
	; _bx = Sector
	; _cx = Size
	; _ah = SCDBank

	; Save MPRs
	tma		#2
	pha
	tma		#3
	pha
	tma		#4
	pha

	; Save Parameters
	stw		_bx,_CLSRtmpsect
	stb		_ah,_CLSRtmpbank
	stw		_cx,_CLSRtmpsize

.loop:
	lda		_al
	pha

	; If Size > 24k, then read first 24k
	cmpw	#24*1024,_cx
	blo		.ok
	stw		#24*1024,_cx
.ok:

	; Save Size
	lda		_cx
	pha
	lda		_cx+1
	pha

	; Get Overlay Sector from Index in _ax
	lda		<_al
	asl		a
	asl		a
	tay
	map		ovlarray
	ldx		ovlarray,Y
	iny
	lda		ovlarray,Y
	stx		<_al
	sta		<_ah

	; Map 24k of SCD Ram to $4000-$A000
	lda		_CLSRtmpbank
	tam		#2
	inc		a
	tam		#3
	inc		a
	tam		#4
	inc		a
	sta		_CLSRtmpbank

	; Add our Sector Offset
	addw	_bx,_ax

	; Store Sector Offset Part 1
	lda		<_al
	sta		<_dl

	; Compute N Sector to load from Size
	addw	#2047,_cx	; Round up Size to 2048
	lda		<_ch
	lsr		a
	lsr		a			; = Size / 2048
	lsr		a
	sta		<_al

	; Store Sector Offset Part 2
	lda		<_ah
	sta		<_ch
	stz		<_cl

	; Local Ram Load
	lda		#1
	sta		<_dh

	; Ram Address
	stw		#$4000,_bx

	; Go Read !
	jsr		cd_read

	; Restore Parameters
	pla
	sta		_cx+1
	pla
	sta		_cx
	pla
	sta		_al

	; Add 12 Sectors (24k) to Sector Base
	addw	#12,_CLSRtmpsect
	stw		_CLSRtmpsect,_bx

	; Substract Readed Size from Size
	subw	_cx,_CLSRtmpsize
	beq		.end
	jmp		.loop

.end:
	; Restore MPRs
	pla
	tam		#4
	pla
	tam		#3
	pla
	tam		#2
#endasm
}
